/*************************************************************/
/*  plotss.c ; Makes a 3D-plot of an image.                  */
/*                                                           */
/*  First version: July 92                                   */
/*  Latest update: June 98, Stefan Spaennare                 */
/*************************************************************/

/*****************************************************************************/
/*                                                                           */
/* Notice:                                                                   */
/* =======                                                                   */
/*                                                                           */
/* I make no warranties that this program is (1) free of error, (2) con-     */
/* sistent with any standard merchantability, or (3) meeting the require-    */
/* ments of a particular application.  This software shall not, partly or    */
/* as a whole, participate in a process, whose outcome can result in injury  */
/* to a person or loss of property. It is solely designed for analytical     */
/* work.  Permission to use, copy, and distribute is hereby granted without  */
/* fee, providing that the header above including this notice appears in     */
/* all copies.                                                               */
/*                                                                           */
/*                                                         Stefan Spaennare  */
/*                                                                           */
/*****************************************************************************/



#include <math.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <time.h>


double timetic=(double)(CLOCKS_PER_SEC);

double pi=3.14159265358979323;


int main(argc,argv)
int argc;
char *argv[];
{

   FILE *infile,*outfile;

   int i,j,k,l,width,height,tempi,j1,i1,max,i2,j2,col,im2size;
   int min,xsize,ysize,xsize2,ysize2;

   double outorigx,outorigy,f,sh,ch,vh,vv,c,amp,cx,cy,bx,by;
   double x,y,z,xs,ys,sv,cv,rot,sw,cw,v,x1,y1,w,im2orig;
   double maxamp,xs2,ys2,s,alfa,fmin,fmax,eps,bg,inorigx,inorigy;
   double fheight,amp2;
   
   clock_t time1,timediff;

   int *colv;

   int xys[3];

   short fff[3];

   short **image,**image2;
   short *mpimage,*mpimage2;

   if (argc<6) {
printf("Usage: %s inimage.sss outimage.sss rotangelr vertangelr ampr powerr\n",argv[0]);
      exit(0);
   } /* if */

  
   if ((infile = fopen(argv[1],"rb")) == NULL) {
      printf("File not found.\n");
      exit(0);
   } /* if */

   outfile=fopen(argv[2],"wb");

   fread(&xys[1],sizeof(int),2,infile);

   xsize=xys[1];
   ysize=xys[2];

 
   image=(short **)calloc(ysize,sizeof(short*));
   mpimage=(short *)calloc(xsize*ysize,sizeof(short));

   for (i=0; i<ysize; i++) {
      image[i]=mpimage;
      mpimage=mpimage+xsize;
   } /* for i */

   xsize2=(int)(sqrt(2.0)*(double)(xsize))+1;
   ysize2=(int)(sqrt(2.0)*(double)(ysize))+1;

   image2=(short **)calloc(ysize2,sizeof(short*));
   mpimage2=(short *)calloc(xsize2*ysize2,sizeof(short));

   for (i=0; i<ysize2; i++) {
      image2[i]=mpimage2;
      mpimage2=mpimage2+xsize2;
   } /* for i */

   for (i=0; i<ysize; i++) {
      for (j=0; j<xsize; j++) {
          fread(&fff[1],sizeof(short),1,infile);
	  image[i][j]=fff[1];
      } /* for j */
   } /* for i */


v=atof(argv[3]);
vv=atof(argv[4]);
amp2=atof(argv[5]);
alfa=atof(argv[6]);

if (amp2 > 1.0) {
   amp2=1.0;
} /* if */


 colv=(int *)calloc(32768+1,sizeof(int));


 for (i=0; i<32768; i++) {
    x=(double)(i);
    colv[i]=(int)(5000.0*sin(2.0*pi*x/(x/20.0+500.0))+20000.0);
 } /* for i */

 vh=0.0*pi/180.0;
 vv=vv*pi/180.0;
 v=v*pi/180;

 width=xsize;
 height=ysize;
 fheight=(double)(height);

 im2size=ysize2;
 im2orig=(double)(im2size-1)/2.0;

 inorigx=(double)(width-1)/2.0;
 inorigy=(double)(height-1)/2.0;

 outorigx=inorigx;
 outorigy=inorigy*(1.0-0.4*cos(vv));


 cx=1.0;
 cy=1.0;
 bx=0.8;
 by=0.8;

 f=6.0*320.0*by*fheight/512.0;
 maxamp=330.0*by*fheight/512.0;

 eps=1.0e-6;

for (i=0; i<im2size; i++) {
   for (j=0; j<im2size; j++) {
      image2[j][i]=0;
   } /* for j */
} /* for i */

 sv=sin(v);
 cv=cos(v);

 min=32768;
 max=0;

 for (i=0; i<width; i++) {
    for (j=0; j<height; j++) {
       x=(double)(i)-inorigx;
       y=(double)(j)-inorigy;

       x1=x*cv-y*sv;
       y1=x*sv+y*cv;

       i1=(int)(x1+im2orig+0.5);
       j1=(int)(y1+im2orig+0.5);

       tempi=image[j][i]+1;
       if (tempi > max) {
          max=tempi;
       }
       if (tempi < min) {
          min=tempi;
       }
       image2[j1][i1]=tempi;
    } /* for j */
 } /* for i */

for (i=0; i<width; i++) {
   for (j=0; j<height; j++) {
      image[j][i]=32767;
   } /* for j */
} /* for i */

sh=sin(vh); 
ch=cos(vh);
sv=sin(vv); 
cv=cos(vv);

fmax=(double)(max);
fmin=(double)(min);
bg=exp(alfa*log(1.0/(fmax-fmin+1.0)));
amp=maxamp/(1.0-bg);

time1=clock();

for (j=0; j<im2size; j++) {
   for (i=0; i<im2size; i++) {
   if (image2[j][i] > 0) {
      x=bx*((double)(i)-im2orig);
      y=-by*((double)(j)-im2orig);
      z=(double)(image2[j][i]);
      z=amp2*amp*(exp(alfa*log((z-fmin+1.0)/(fmax-fmin+1.0)))-bg);
      s=z-(double)((int)(z))-eps;
      while (s < z)  {
         xs=cx*(x*(f-y*cv)/f*ch+y*sh)+outorigx;
         ys=cy*(s*(f-y*ch)/f*cv+y*sv)+outorigy;
         i1=(int)(xs+0.5);
         j1=(int)(fheight-ys+0.5);
         col=colv[(int)(32767.0/maxamp*s)];
         if ((i1>=0) && (i1<width)) {
            if ((j1>=0) && (j1<height)) {
                image[j1][i1]=col;
            } /* if */
         } /* if */
         s=s+1.0;
      } /* while */
   } /* if */
   } /* for j */
} /* for i */ 

timediff=clock()-time1;

printf("%12.2f\n",(double)(timediff)/timetic);

   fwrite(&xys[1],sizeof(int),2,outfile);

   for (i=0; i<ysize; i++) {
      for (j=0; j<xsize; j++) {
         fff[1]=image[i][j];
         fwrite(&fff[1],sizeof(short),1,outfile);
      } /* for j */
   } /* for i */

} /* End  */
